import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.Random;
import java.util.TreeMap;
import java.util.stream.IntStream;
import java.util.stream.Collectors;

/**
 * This program is a demo of using Java's stream API for some simple computations,
 * using only operations on steams (and System.out).
 */
public class SimpleStreams {
	
	public static void main(String[] args) {
		
		
		/* 1. Use IntStream.range(a,b) to print 10 lines showing n and n*n for n = 1, 2, ..., 10. */
		
		
		/* 2. Use IntStream.range(a,b) to find the sum of 1.0/n for the integer n = 1, 2, 3, ..., 100000.  
		 *    Print the answer.   (You don't need the stream API for printing the answer!)  */
		
		
		/* 3. Use a stream of values from the random number generator, rand, to generate 100000 random
		 *    integers in the range 1 through 1000 and count how many of the random numbers are perfect squares.
		 *    A number n is a perfect square if Math.sqrt(x) == (int)Math.sqrt(x).  Print the answer. */
		
		Random rand = new Random();
		
		
		/* 4. The array, names, defined below is an array of object of type Name.  An object, name,
		 *    of type Name contains two strings: a first name, name.first, and a last name, name.last.  
		 *    You can use Arrays.stream(names) to make a stream containing all of the elements of the array.
		 *        Use the stream API to print all the names from the table whose last name begins
		 *     with the letter 'S'. */
		
		
		/* 5. Use the stream API to count out how many names in the array, names, have last name "Stark",
		 *    and print the answer. */
		
		
		/* 6. Use the stream API to find and print the sum of the lengths of all the names in the
		 *    array that have last name "Stark", and print the answer.  (For a Name n, you can get
		 *    the length of the name using n.toString().length(). */


		/* 7. Use the stream API to find the name from the array that has the longest first name,
		 *    and print the answer. */
		
		
		/*  Complex example: use the "groupingBy" collector to split an array of names by last name.
		 *  Copy the plain "Map" into a TreeMap to sort the entries by last name.
		 *  Then print the resulting families in a nice format.  THIS IS NOT AN ASSIGNMENT!
		 *  UNCOMMENT THE FOLLOWING CODE SEGMENT IF YOU WANT TO SEE THE OUTPUT. */
		
//		Map<String, List<Name>> families;
//		families = Arrays.stream(names).collect(Collectors.groupingBy( name -> name.last ));
//		TreeMap<String, List<Name>> sortedFamilies = new TreeMap<>(families);
//		System.out.println();
//		for ( String lastName : sortedFamilies.keySet() ) {
//			List<Name> family = sortedFamilies.get(lastName);
//			System.out.println(lastName + ":");
//			for ( Name name : family)
//				System.out.println( "     " + name );
//		}
		
	} // end main()
	
	/**
	 * Represents a name consisting of a first name and a last name.
	 */
	static class Name {
		String first;
		String last;
		Name(String first, String last) {
			this.first = first;
			this.last = last;
		}
		public String toString() {
			return first + " " + last;
		}
	}

	/**
	 * Some character names from a TV show of which I am not a fan.
	 */
	static Name[] names = new Name[] {
			new Name("Eddard", "Stark"),
			new Name("Catelyn", "Tully"),
			new Name("Daenerys", "Targaryen"),
			new Name("Jon", "Snow"),
			new Name("Tyrion", "Lannister"),
			new Name("Bran", "Stark"),
			new Name("Sansa", "Stark"),
			new Name("Arya", "Stark"),
			new Name("Cersei", "Lannister"),
			new Name("Jaime", "Lannister"),
			new Name("Petyr", "Baelish"),
			new Name("Robert", "Baratheon"),
			new Name("Jorah", "Mormont"),
			new Name("Viserys", "Targaryen"),
			new Name("Khal", "Drogo"),
			new Name("Joffrey", "Baratheon"),
			new Name("Sandor", "Clegane"),
			new Name("Robb", "Stark"),
			new Name("Maester", "Luwin"),
			new Name("Theon", "Greyjoy"),
			new Name("Rodrik", "Cassel"),
			new Name("Tywin", "Lannister"),
			new Name("Lysa", "Arryn"),
			new Name("Jeor", "Mormont"),
			new Name("Samwell", "Tarly"),
			new Name("Allister", "Thorne"),
			new Name("Illyrio", "Mopatis"),
			new Name("Barristan", "Selmy"),
			new Name("Renly", "Baratheon"),
			new Name("Stannis", "Baratheon"),
			new Name("Ilyn", "Payne"),
			new Name("Gregor", "Clegane"),
			new Name("Rickon", "Stark"),
			new Name("Aerys", "Targaryen"),
			new Name("Rhaegar", "Targaryen"),
			new Name("Jon", "Arryn")
		};	
	
}
